package geometry.part3;

import geometry.part2.LineSegment;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

/**
 * 総当たり法による線分の交差検出
 */
public class BruteForceIntersectionDetector implements IntersectionDetector {
    public Collection<Intersection> execute(List<LineSegment> segments) {
        List<Intersection> result = new ArrayList<Intersection>();
        int size = segments.size();
        for (int i = 0; i < size; i++) {
            LineSegment s1 = segments.get(i);
            // j < iの場合は調査済み、またj = iの場合は2線分が同一となり交差を調べる
            // 必要がないため、j = i + 1からループを開始する
            for (int j = i + 1; j < size; j++) {
                LineSegment s2 = segments.get(j);
                if (s1.intersects(s2)) {
                    result.add(new Intersection(s1, s2));
                }
            }
        }
        return result;
    }
}
